const Lang = imports.lang;
const Main = imports.ui.main;


function init() {
	return new LightOverview();
}

function LightOverview() {
    this._init();
}

LightOverview.prototype = {
	_init: function() {
		this.old_x = Main.overview._viewSelector.actor.x;
		this.old_width = Main.overview._viewSelector.actor.get_width();
	},
	
	enable: function() {
		this.showingId = Main.overview.connect("showing", Lang.bind(this, this.showLightOverview));
		this.hidingId = Main.overview.connect("hiding", Lang.bind(this, this.hideLightOverview));
	},
	
	disable: function() {
		Main.overview.disconnect(this.showingId);
		Main.overview.disconnect(this.hidingId);
		this.revertAllChanges();
	},

	showLightOverview: function() {
		//message tray
		Main.messageTray.actor.hide();
		
		//search
		Main.overview._searchEntry.hide();
		
		//dash
		Main.overview._dash.actor.hide();
		Main.overview._viewSelector.actor.set_x(0);
		Main.overview._viewSelector.actor.set_width(Main.overview._group.get_width());
	},
	
	hideLightOverview: function() {
		//message tray
		Main.messageTray.actor.show();
	},

	revertAllChanges: function() {
		//search
		Main.overview._searchEntry.show();

		//dash
		Main.overview._dash.actor.show();
		Main.overview._viewSelector.actor.set_x(this.old_x);
		Main.overview._viewSelector.actor.set_width(this.old_width);
	}
};
